
#include <config.h>

#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>

#include "glade-project.h"

#include "vuc-plugin-utils.h"


gchar * glade_gtk_text_buffer_get_text (GtkTextBuffer * buffer)
{
  GtkTextIter start, end;

  gtk_text_buffer_get_bounds(buffer, &start, &end);
  return gtk_text_buffer_get_text(buffer, &start, &end, TRUE);
}

void glade_gtk_text_buffer_set_prop (GtkTextBuffer * buffer, gchar * name, gchar * value)
{
  GtkTextIter start, end;
  GtkTextTag * tag= gtk_text_buffer_create_tag(buffer, NULL, name, value, NULL);

  gtk_text_buffer_get_bounds(buffer, &start, &end);
  gtk_text_buffer_apply_tag(buffer, tag, &start, &end);
}

VucGladeProjectPlugin * glade_project_get_plugin_data (GladeProject * project)
{
  if (!project->plugin) {
    GtkTextBuffer * txt= gtk_text_buffer_new(NULL);
    glade_gtk_text_buffer_set_prop(txt, "font", VUC_GLADE_EDIT_FONT);

    project->plugin= g_malloc0(sizeof(VucGladeProjectPlugin));
    ((VucGladeProjectPlugin *)project->plugin)->lang= -1;
    ((VucGladeProjectPlugin *)project->plugin)->header= txt;
    ((VucGladeProjectPlugin *)project->plugin)->exe_args= gtk_entry_buffer_new(NULL, 0);
    ((VucGladeProjectPlugin *)project->plugin)->curdir= g_get_current_dir();
  }
  return project->plugin;
}

#ifndef HAVE_XTOI

/*
**	Copyright (c) Leigh Brasington 2012.  All rights reserved.
**	This code may be used and reproduced without written permission.
**
**	Convert an ANSI hexadecimal string to an int
**
**	Keywords: Convert hexadecimal string int C/C++
*/
unsigned int xtoi (const char *hexstring)
{
	unsigned int	i = 0;

	if ((*hexstring == '0') && (*(hexstring+1) == 'x'))
		hexstring += 2;
	while (*hexstring)
	{
		char c = g_ascii_toupper(*hexstring++);
		if ((c < '0') || (c > 'F') || ((c > '9') && (c < 'A')))
			break;
		c -= '0';
		if (c > 9)
			c -= 7;
		i = (i << 4) + c;
	}
	return i;
}

#endif
